/*
 * Copyright (c) 2023, NVIDIA CORPORATION. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *  * Neither the name of NVIDIA CORPORATION nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/* Compiler headers */
#include <stdint.h>
#include <stdbool.h>

/* Early FSP headers */
#include <misc/ct-assert.h>       // for CT_ASSERT

/* Hardware headers */

/* Late FSP headers */
#include <osa/rtos-values.h>
#include <osa/rtos-errors.h>
#include <osa/rtos-task.h>
#include <osa/rtos-queue.h>
#include <tke/tke-tegra.h>
#include <error/common-errors.h>             // for E_SUCCESS, error_t, FSP_...

/* Module-specific FSP headers */
#include <utc/sections-utc.h>              // for SECTION_UART_ ...
#include <utc/utc-errors.h>                // for E_UTC_...
#include <utc/utc-port.h>                  // for utc_port_...

/*
 * Compile-time check for FSP header files
 *   Each FSP header file contains a signature unique to that file, and the
 *   FSP project.  The CT_ASSERT macro (contained in misc/ct-assert.h) can
 *   check for this signature.  If it does not exist, then the build will
 *   abort.
 *
 *   This is a trap for projects which have their own include files of the
 *   same names, but different contents.  This trap ensures that only the
 *   files from the FSP project, are built into the FSP source code.
 */
START_RFD_BLOCK(MISRA, DEVIATE, Rule_1_2, "Approval: Bug 200531996, DR: SWE-FSP-009-SWSADR.docx",
                MISRA, DEVIATE, Directive_4_9, "Approval:  On-file, DR: SWE-FSP-012-SWSADR.docx")
CT_ASSERT(FSP__ERROR__COMMON_ERRORS_H, "Header file missing or invalid.")
CT_ASSERT(FSP__OSA__RTOS_TASK_H, "Header file missing or invalid.")
CT_ASSERT(FSP__OSA__RTOS_QUEUE_H, "Header file missing or invalid.")
END_RFD_BLOCK(MISRA, DEVIATE, Rule_1_2, "Approval: Bug 200531996, DR: SWE-FSP-009-SWSADR.docx",
              MISRA, DEVIATE, Directive_4_9, "Approval:  On-file, DR: SWE-FSP-012-SWSADR.docx")

#define UTC_QUEUE_SIZE        rtosQueueSize(256, sizeof(char))

error_t utc_port_rx_queue_send_from_isr(uintptr_t rx_queue,
                                        char *c_in,
                                        bool *isr_yield_flag)
{
    error_t   ret = E_SUCCESS;
    rtosError status;
    rtosBool  higher_prio_task_woken = rtosFALSE;

    if (rx_queue == 0U) {
        ret = E_UTC_NULL_PTR;
        goto out;
    }

    status = rtosQueueSendFromISR((rtosQueueHandle) rx_queue,
                                  c_in,
                                  &higher_prio_task_woken);
    if (status != rtosPASS) {
        ret = status;
        goto out;
    }
    *isr_yield_flag = higher_prio_task_woken;

out:
    return ret;
}

error_t utc_port_rx_queue_receive(uintptr_t rx_queue,
                                  char *c,
                                  uint32_t timeout)
{
    error_t   ret = E_SUCCESS;
    rtosError status;
    rtosTick  timeout_in_ticks = tegra_tke_convert_usecs_to_ticks(timeout);

    if ((rx_queue == 0U) || (c == NULL)) {
        ret = E_UTC_NULL_PTR;
        goto out;
    }

    if (timeout_in_ticks >= rtosMAX_DELAY) {
        timeout_in_ticks = rtosMAX_DELAY;
    }

    status = rtosQueueReceive((rtosQueueHandle) rx_queue,
                              c,
                              timeout_in_ticks);
    if (status != rtosPASS) {
        ret = status;
        goto out;
    }

out:
    return ret;
}

void utc_port_isr_exit(bool isr_yield_flag)
{
    rtosTaskYieldFromISR((rtosBool) isr_yield_flag);
}

error_t utc_port_rx_queue_create(uintptr_t *rx_queue)
{
    error_t   ret = E_SUCCESS;
    rtosError status;
    static char utc_rx_queue[UTC_QUEUE_SIZE] SECTION_UTC_DATA;

    status = rtosQueueCreate(utc_rx_queue,
                             ARRAY_SIZE(utc_rx_queue),
                             256U,
                             sizeof(char),
                             (rtosQueueHandle *)rx_queue);
    if (status != rtosPASS) {
        ret = status;
        goto out;
    }

out:
    return ret;
}

uint64_t utc_port_get_elapsed_usecs(const uint64_t start)
{
    return tegra_tke_get_elapsed_usecs64(start);
}
